# -*- coding: utf-8 -*-
# modified by Venom for Fenomscrapers (updated 12-23-2020)
'''
	Fenomscrapers Project
'''

import re

try: from urlparse import parse_qs, urljoin, urlparse
except ImportError: from urllib.parse import parse_qs, urljoin, urlparse
try: from urllib import urlencode, quote_plus
except ImportError: from urllib.parse import urlencode, quote_plus

from fenomscrapers.modules import cfscrape
from fenomscrapers.modules import cleantitle
from fenomscrapers.modules import client
from fenomscrapers.modules import source_utils


class source:
	def __init__(self):
		self.priority = 21
		self.language = ['en']
		self.domains = ['scene-rls.com', 'scene-rls.net']
		self.base_link = 'http://scene-rls.net'
		self.search_link = '/?s=%s'


	def movie(self, imdb, title, aliases, year):
		try:
			url = {'imdb': imdb, 'title': title, 'aliases': aliases, 'year': year}
			url = urlencode(url)
			return url
		except:
			return


	def tvshow(self, imdb, tvdb, tvshowtitle, aliases, year):
		try:
			url = {'imdb': imdb, 'tvdb': tvdb, 'tvshowtitle': tvshowtitle, 'aliases': aliases, 'year': year}
			url = urlencode(url)
			return url
		except:
			return


	def episode(self, url, imdb, tvdb, title, premiered, season, episode):
		try:
			if not url: return
			url = parse_qs(url)
			url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
			url['title'], url['premiered'], url['season'], url['episode'] = title, premiered, season, episode
			url = urlencode(url)
			return url
		except:
			return


	def sources(self, url, hostDict):
		sources = []
		if not url: return sources
		try:
			scraper = cfscrape.create_scraper()
			data = parse_qs(url)
			data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])

			title = data['tvshowtitle'] if 'tvshowtitle' in data else data['title']
			title = title.replace('&', 'and').replace('Special Victims Unit', 'SVU')
			aliases = data['aliases']
			episode_title = data['title'] if 'tvshowtitle' in data else None
			year = data['year']
			hdlr = 'S%02dE%02d' % (int(data['season']), int(data['episode'])) if 'tvshowtitle' in data else year

			query = '%s %s' % (title, hdlr)
			query = re.sub('(\\\|/| -|:|;|\*|\?|"|\'|<|>|\|)', '', query)
			url = self.search_link % quote_plus(query)
			url = urljoin(self.base_link, url)
			# log_utils.log('url = %s' % url, log_utils.LOGDEBUG)
			r = scraper.get(url).content
			posts = client.parseDOM(r, 'div', attrs={'class': 'post'})
			if not posts: return sources
		except:
			source_utils.scraper_error('SCENERLS')
			return sources

		items = []
		for post in posts:
			try:
				content = client.parseDOM(post, "div", attrs={"class": "postContent"})
				size = re.findall('((?:\d+\,\d+\.\d+|\d+\.\d+|\d+\,\d+|\d+)\s*(?:GiB|MiB|GB|MB))', content[0])[0]
				u = client.parseDOM(content, "h2")
				u = client.parseDOM(u, 'a', ret='href')
				u = [(i.strip('/').split('/')[-1], i, size) for i in u]
				items += u
			except:
				source_utils.scraper_error('SCENERLS')
				return sources

		for item in items:
			try:
				name = item[0]
				name = client.replaceHTMLCodes(name)
				if not source_utils.check_title(title, aliases, name, hdlr, year): continue
				name_info = source_utils.info_from_name(name, title, year, hdlr, episode_title)
				if source_utils.remove_lang(name_info): continue

				# check year for reboot/remake show issues if year is available-crap shoot
				# if 'tvshowtitle' in data:
					# if re.search(r'([1-3][0-9]{3})', name):
						# if not any(value in name for value in [year, str(int(year)+1), str(int(year)-1)]):
							# continue

				quality, info = source_utils.get_release_quality(name_info, item[1])
				try:
					dsize, isize = source_utils._size(item[2])
					info.insert(0, isize)
				except:
					dsize = 0
				info = ' | '.join(info)

				url = item[1]
				if any(x in url for x in ['.rar', '.zip', '.iso', '.sample.']): continue

				url = client.replaceHTMLCodes(url)
				try: url = url.encode('utf-8')
				except: pass
				if url in str(sources): continue

				host = re.findall('([\w]+[.][\w]+)$', urlparse(url.strip().lower()).netloc)[0]
				if not host in hostDict: continue

				host = client.replaceHTMLCodes(host)
				try: host = host.encode('utf-8')
				except: pass

				sources.append({'provider': 'scenerls', 'source': host, 'name': name, 'name_info': name_info, 'quality': quality, 'language': 'en', 'url': url,
											'info': info, 'direct': False, 'debridonly': True, 'size': dsize})
			except:
				source_utils.scraper_error('SCENERLS')
		return sources


	def resolve(self, url):
		return url